 
/*

DO NOT COPY or distribute this software with out PERMISSION from TDS200

Contact info: " tds200products@gmail.com ".

MCPE:Mech 3D Plane Mod

Created By TDS200

v0.2.0
*/
 
 
 /*
 Bug fixes
 
 
 */
 
 var plane;
var isOnplane = false;
var playerDir = [0, 0, 0];
var DEG_TO_RAD = Math.PI / 180;
var planeSpeed = 0.5;
var rotFix;
var planeonmap = false;


var timer = 0;
var gasAmount = 1;

Renderer = Renderer.createHumanoidRenderer();
addMobToRenderer(Renderer);





function addMobToRenderer(renderer){
model = renderer.getModel();

model.getPart("head").clear();
model.getPart("body").clear();
model.getPart("rightArm").clear();
model.getPart("leftArm").clear();
model.getPart("rightLeg").clear();
model.getPart("leftLeg").clear();

bipedBody = model.getPart("body");
bipedBody.setTextureOffset(0,0);

             //   x    y    F/B   x   y   F/B
 
bipedBody.addBox(-10 , -1 , -16 , 20 , 10 , 30 );

bipedBody.addBox( -40 , 0 , -15 , 80 , 3 , 20 );
bipedBody.addBox( -40 , -20 , -15 , 80 , 3 , 20 );
bipedBody.addBox( -35 , -20 , -13 , 3 , 20 , 2 );
bipedBody.addBox( -35 , -20 , 1 , 3 , 20 , 2 );
bipedBody.addBox(  35 , -20 , -13 , 3 , 20 , 2 );
bipedBody.addBox(  35 , -20 , 1 , 3 , 20 , 2 );

bipedBody.addBox( -12 , -20 , -13 , 3 , 20 , 2 );
bipedBody.addBox( -12 , -20 , 1 , 3 , 20 , 2 );
bipedBody.addBox(  12 , -20 , -13 , 3 , 20 , 2 );
bipedBody.addBox(  12 , -20 , 1 , 3 , 20 , 2 );


bipedBody.addBox(-7 , 1.5 , 14 , 14 , 6 , 27 );
bipedBody.addBox(-20 ,  3  , 30 , 40 , 3 , 10 );
bipedBody.addBox(-1.5 , -10 , 30 , 3 , 20 , 10 );


bipedBody.addBox( -2 , 6 , -19 , 4 , 8 , 2 );
bipedBody.addBox( -2 , -6 , -19 , 4 , 8 , 2 );
bipedBody.addBox(-10 , 2, -19 , 8 , 4 , 2 );
bipedBody.addBox( 2 , 2 , -19 , 8 , 4 , 2 );


bipedBody.addBox(  8 , -0 , -13 , 3 , 15 , 2 );
bipedBody.addBox( -8 , -0 , -13 , 3 , 15 , 2 );

bipedBody.setTextureSize(1,1);

bipedBody.addBox(-2 , 2 , -20 , 4 , 4 , 4 );
bipedBody.addBox(  8 , 13 , -16 , 4 , 8 , 8 );
bipedBody.addBox( -8 , 13 , -16 , 4 , 8 , 8 );
}





/*
function procCmd(){
Player.addItemInventory(476,1,0);
Player.addItemInventory(471,1,0);
Player.addItemInventory(475,1,0);
}
*/




function attackHook(attacker , victim){

if(attacker == plane){
preventDefault();
}

if(victim == plane && getCarriedItem() == 471 ){
preventDefault();
Entity.rideAnimal(getPlayerEnt(),plane);
isOnplane = true;
}

if(victim == plane && getCarriedItem() == 475 ){
preventDefault();
gasAmount = 5000
clientMessage(ChatColor.BLUE + "Fuel level:[||||||||||]");
}


if(victim == plane && getCarriedItem() != 471 && getCarriedItem() != 475){
Level.dropItem(Entity.getX(plane) , Entity.getY(plane) , Entity.getZ(plane) , 0 , 476 , 1 , 0);
Entity.remove(plane);
planeonmap = false;
ModPE.saveData("planeonmap","false");
}

}




function useItem(x,y,z,i,b) {
var block = getTile(x,y+1,z);

if(i == 476 && planeonmap == true){
clientMessage("You cannot place more than one plane per map!");
}

if(i == 476 && planeonmap == false) {

plane = Level.spawnMob(x,y+1,z,11);

Entity.setMobSkin(plane, "mob/woodenplane.png");

Entity.setRenderType(plane , Renderer.renderType);

Entity.setHealth(plane , 10000);

//Entity.rideAnimal(getPlayerEnt(),plane);
//isOnplane = true;

planeonmap = true;
ModPE.saveData("planeonmap","true");
Player.addItemInventory(476,-1,0);
}

}

function modTick() {

timer++;

if(ModPE.readData("planeonmap") == "true" && timer > 50 && timer < 51){
Level.dropItem(getPlayerX() , getPlayerY() , getPlayerZ() , 0 , 476 , 1 , 0);
ModPE.saveData("planeonmap","false");
}




if(getYaw() > 360 || getYaw() < -360){
setRot(getPlayerEnt(),0,getPitch());
}


if(gasAmount == 3750){
clientMessage(ChatColor.BLUE+"Fuel Level: [||||||||   ]");
}


if(gasAmount == 2500){
clientMessage(ChatColor.BLUE+"Fuel Level: [|||||     ]");
}


if(gasAmount == 1250){
clientMessage(ChatColor.RED+"Fuel Level: [|||       ]");
}


if(gasAmount == 0){
clientMessage(ChatColor.RED+"Out Of Fuel.");
}

if(gasAmount < 0 ){
isOnplane = false;
unmannedplane();
}



if(getPlayerX() <  Entity.getX(plane) -1 || getPlayerX() >  Entity.getX(plane) +1  || getPlayerZ() <  Entity.getZ(plane) -1 || getPlayerZ() >  Entity.getZ(plane) +1){
isOnplane = false;
unmannedplane();
}


if(isOnplane == true) {
planeTick();
var planeblock = getTile(Entity.getX(plane),Entity.getY(plane)-1,Entity.getZ(plane));
var planeblockup = getTile(Entity.getX(plane),Entity.getY(plane),Entity.getZ(plane));

//clientMessage(getYaw());
//clientMessage(Entity.getYaw(plane));


gasAmount--;



if(getYaw() > Entity.getYaw(plane) + 30 ){
rotFix = 30;
}

if(getYaw() < Entity.getYaw(plane) - 15 && getYaw() > Entity.getYaw(plane) + 15 ){
rotFix = 0;
}


if(getYaw() < Entity.getYaw(plane) - 30 ){
rotFix = -30;
}


Level.playSoundEnt(plane , "random.fuse" , 100 , 30 );

setRot(plane , getYaw() + rotFix , 0 );



}

}

function planeTick() {
toDirectionalVector(playerDir, (getYaw() + 90) * DEG_TO_RAD , getPitch() * DEG_TO_RAD * -1);
setVelX(plane, planeSpeed * playerDir[0]);
setVelY(plane, planeSpeed * playerDir[1]);
setVelZ(plane, planeSpeed * playerDir[2]);

}

function toDirectionalVector(vector, yaw, pitch) {	
vector[0] = Math.cos(yaw) * Math.cos(pitch);

if(getPitch() < 3 && getPitch() > -3 ){
vector[1] = Math.sin(pitch);
}

if(getPitch() > 3){
vector[1] = -0.3;
}

if(getPitch() < -3){
vector[1] = 0.3;
}

vector[2] = Math.sin(yaw) * Math.cos(pitch);
}
  
  
  
function unmannedplane(){
setVelX(plane,0);
setVelY(plane,-0.5);
setVelZ(plane,0);
setRot(plane , 0 , 0 );
}  
  




function leaveGame(){
if(planeonmap == true){
ModPE.saveData("planeonmap","true");
}
}
